
Silo - Bug # 594: silo's compression test is bogus

Status: Resolved Priority: Normal

Author: Mark Miller Category:
Updated: 08/30/2012 Due date:

Likelihood: 2 - Rare

Severity: 4 - Crash / Wrong Results

Silo Found in Version: 4.8

OS: All

Support Group: Any

Subject: silo's compression test is bogus

Description: One of silo's tests, compression.c, is intended to drive hdf5 in various ways using compression, etc.

However, it uses only DBWrite() calls and there isn't logic in the HDF5 driver to handle setting of dxpl for 

H5Dwrite calls for that function. Now, even funnier is the fact that somehow, the compression test still winds 

up compressing datasets that get written. So, I am guessing that somehow the property list for dataset 

transfer (or maybe creation) is getting left around in a _set-for-compression_ state and that is how H5Dwrite 

calls are ultimately getting compression applied.



The minratio1000 test fails. I had thought the problem was in HDF5. However, it fails to write data *correctly*. 

The problem is that Silo does not detect and report the failed write even with errmode set to FAIL.



Ok, I figured out why a Silo DBWrite call, although having no specific logic to handle compression, still winds 

up getting compressed. There are some hid_t _pointers_ to dataset creation properties in the driver; 

@P_crprops@ and @P_ckcrprops@. All ccompression stuff is handled via @P_ckcrprops@. But, under 

various conditions, @P_crprops@, which is otherwise H5P_DEFAULT, gets set equal to @P_ckcrprops@ 

and then never gets set back. So, @P_ckcrprops@ then effects any H5Dcreate call thereafter that uses 

@P_crprops@.

History

02/10/2011 12:10 am - Mark Miller

- Assigned to set to Mark Miller

- Estimated time set to 2.00

- Likelihood changed from 3 - Occasional to 2 - Rare

- Severity changed from 2 - Minor Irritation to 4 - Crash / Wrong Results

- Silo Found in Version set to 4.8

02/10/2011 12:28 am - Mark Miller

- Target version set to HDF5-1.8.7

02/14/2011 12:30 pm - Mark Miller

- Project changed from HPC-HDF5 to Silo

08/30/2012 08:49 pm - Mark Miller

- Status changed from New to Resolved

Fixes to the HDF5 library in 1.8.8 have improved behaviour significantly.
